{% extends "flask_user_layout.html" %}
{% block content %}
<div class="container">
    <h2>Movies</h2>

    <div class="flex-container" style="display: flex; justify-content: space-between; margin-top: 20px; margin-bottom: 10px">
        <div style="align-self: flex-start">
            <form class="form-inline my-2 my-lg-0" action="" method="GET">
                <input class="form-control mr-sm-2" type="search" name='search_word' placeholder="Search for movie..." aria-label="Search">
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Go</button>
            </form>
        </div>

        <div style="align-self: flex-end">
            <button type="button" class="btn btn-danger" id="deleteButton">Delete Ratings</button>
        </div>
    </div>

    <div id="moviediv">
        <input type="hidden" id="searchInput" value={{ search_word }}>
        {% for m in movies %}
            <div class="panel panel-default">
                <div class="panel-heading">
                    <b>{{ m[0].title }}</b>
                    <a href={{m[2][0]}} class="btn btn-warning" role="button">IMDB Link</a>
                    <a href={{m[2][1]}} class="btn btn-info" role="button">TMDB Link</a>
                </div>
                <div class="panel-body">
                    <p>
                        {% for g in m[0].genres %}
                            <span class="label label-default">{{ g.genre }}</span>
                        {% endfor %}

                        {% for t in m[1] %}
                            <span class="label label-primary">&quot;{{ t.tag }}&quot;</span>
                        {% endfor %}

                    </p>
                </div>
                  <div class="panel-footer movie-rating">Rate:
                      <a href="#" class="card-link" data-movieid={{ m[0].id }}>1</a>
                      <a href="#" class="card-link" data-movieid={{ m[0].id }}>2</a>
                      <a href="#" class="card-link" data-movieid={{ m[0].id }}>3</a>
                      <a href="#" class="card-link" data-movieid={{ m[0].id }}>4</a>
                      <a href="#" class="card-link" data-movieid={{ m[0].id }}>5</a> Stars
                  </div>
            </div>
        {% endfor %}
    </div>

    <button type="button" class="btn btn-secondary" id="loadButton" value="0">Load More</button>

</div>

<script>
    // Function to handle the click event on any rating link
    function rateMovie(event) {
        event.preventDefault(); // Prevent the default anchor action
        var movieid = this.getAttribute('data-movieid');
        var rating = this.textContent;
        var elem = this;

        // Create an AJAX request
        var xhr = new XMLHttpRequest();
        xhr.open('POST', '/rate', true);
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

        // Handle the response
        xhr.onload = function() {
            if (xhr.status === 200) {
                // Replace the entire div with the response
                elem.parentElement.innerHTML = xhr.responseText;
            } else {
                alert('Request failed. Returned status of ' + xhr.status);
            }
        };

        // Send the request with the movie ID and the rating
        xhr.send('movieid=' + movieid + '&rating=' + rating);
    }

    function deleteRatings(event) {
        event.preventDefault();

        if (!confirm("Delete Ratings?")) {
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('POST', '/delete', true);
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

        xhr.onload = function() {
            if (xhr.status === 200) {
                window.alert("Ratings deleted!");
            } else {
                alert('Request failed. Returned status of ' + xhr.status);
            }
        };

        xhr.send();
    }

    function loadMore(event) {
        event.preventDefault();

        var loadButton = document.getElementById("loadButton");
        var movieNumbers = parseInt(loadButton.value);
        var elem = this;
        var searchWord = document.getElementById('searchInput').value;

        movieNumbers += 10;
        loadButton.value = movieNumbers;

        var xhr = new XMLHttpRequest();
        xhr.open('POST', '/load', true);
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

        xhr.onload = function() {
            if (xhr.status === 200) {
                var div = document.getElementById('moviediv');
                div.innerHTML += xhr.responseText;

                var links = document.querySelectorAll('.movie-rating .card-link');
                for (var i = 0; i < links.length; i++) {
                    links[i].addEventListener('click', rateMovie);
                }

            } else {
                alert('Request failed. Returned status of ' + xhr.status);
            }
        };

        xhr.send('movieNumbers=' + movieNumbers + '&searchWord=' + searchWord);
    }

    // Attach the event listener to each rating link
    var links = document.querySelectorAll('.movie-rating .card-link');
    for (var i = 0; i < links.length; i++) {
        links[i].addEventListener('click', rateMovie);
    }

    var deleteButton = document.getElementById("deleteButton");
    var loadButton = document.getElementById("loadButton");

    deleteButton.addEventListener('click', deleteRatings);
    loadButton.addEventListener('click', loadMore);

</script>

{% endblock %}
